import { Component, OnInit, ViewChild, ElementRef } from '@angular/core';
import { FormGroup, FormControl, NgForm, Form } from '@angular/forms';
import { User } from 'src/app/shared/models/User';
import { UserService } from 'src/app/shared/services/userService';

@Component({
  selector: 'app-create-user',
  templateUrl: './create-user.component.html',
  styleUrls: ['./create-user.component.scss']
})
export class CreateUserComponent implements OnInit {

  formChangesSubscription : any
  user : User;
  profiles : any;
  formData: FormData;


  @ViewChild('createForm',{static:false}) ngForm: NgForm;

  constructor(private userService : UserService) { }

  ngOnInit() {
    this.formData = new FormData();
    this.userService.getAllProfiles().subscribe(
      (data)=>{
        this.profiles = data
      }
    );
  }

  createUser(data){
    console.log("Creating the user...." + JSON.stringify(data.value));
    console.log(data);
    this.user = new User();
    this.user.nom = data.value['nom'];
    this.user.prenom = data.value['prenom'];
    this.user.code = data.value['code'];
    this.user.email = data.value['email'];
    this.user.photoPath = data.value['photo'];
    this.user.isGenerated = data.value['isGenerated'];
    this.user.profile = data.value['profile'];
    this.user.isEmail = data.value['isEmail'];
    this.user.isExpiring = data.value['isExpiring'];
    if(this.user.isGenerated)
      this.user.password = "autogenerated";

    console.log("User to submit : " + JSON.stringify(this.user));

    //this.formData.append('user',JSON.stringify(this.user));
    this.userService.createUserWithImage( this.formData,this.user).subscribe((data)=> {console.log(data)});
  }

  onFileChange(event){
    if (event.target.files.length > 0) {
      const file = event.target.files[0];
      this.formData.append('photo',file);
    }
  }

}
